#include "AnalysisPipeline.h"
#include "RendererGLUT.h"
#include "VisWindow.h"
#include "ParamParser.h"

int main(int argc, char** argv )
{
//	std::cout<<"[INFO] Testing linear algebra package"<<std::endl;
//	int mtxFormat = LinAlgMatrixSparseReal::SUPPORT_CX_SPARSE;
//	int nz = 3;
//	LinAlgMatrixSparseReal A(3, 2, mtxFormat, nz);
//	A.AddVal(0, 1, 1);
//	A.AddVal(1, 0, 2);
//	A.AddVal(2, 1, 5);
//	A.Factorize();
//	
//	LinAlgVectorReal b(3);
//	b(0) = 0;
//	b(1) = 1;
//	b(2) = .5;
//	
//	LinAlgVectorReal x(2);
//	A.SolveFactorized(b, x);
//	
//	std::cout<<"x=["<<x(0)<<" "<<x(1)<<"];"<<std::endl;;
//	
//	exit(0);
	
	
	bool valid;
	if (argc<2)
	{
		std::cout<<"Usage: "<<argv[0]<<" settings.txt [optionalSettings]"<<std::endl;
		exit(0);
	}
	
	const char ** constArgv=(const char**)argv;
	ParamParser params(argv[1], &(constArgv[2]), argc-2);
	AnalysisPipeline pipeline(params);
	std::cout<<"Finished Analyzing DB"<<std::endl;

	if (params.GetStrValue("Pipeline", "Visualize", valid)=="true")
	{
#ifdef VISUALIZATION	
		std::cout<<"Running Visualiaztion"<<std::endl;
		ParamParser drawParams(params.GetStrValue("Pipeline", "VisSettings"));
		DatabaseVisWindow * visWindow = new DatabaseVisWindow(drawParams, pipeline);
		pipeline.InitRenderingParams(visWindow, &drawParams);
		VisWindowRenderer * visWindowImplementation = new RendererGLUT(argc, argv, visWindow);
#else
		std::cout<<"[WARNING] Visualization disabled (compiling flag)"<<std::endl;
#endif
	}

	
	return 0;
}


