/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __CollectionRadiosityFullMtx_H
#define __CollectionRadiosityFullMtx_H

#include "CollectionDiffuse.h"
#include "LinAlgMatrixSparseReal.h"
#include "CorrCollection.h"
#include "TimeProfiler.h"
#include "Sortable.h"

class CollectionRadiosityFullMtx : public CollectionDiffuse
{
	public:
		CollectionRadiosityFullMtx(const VKString & collectionName, 
								   ModelDatabase * db);
		CollectionRadiosityFullMtx(const VKString & collectionName, 
								   ModelDatabase * db,
								   const CorrMtxParams & mtxParams);
		virtual void InitCollection();
	
		virtual void GetCorrs(const ModelPoint & pnt,	
							  std::vector<ModelPoint> * corrPnts);		
	
		virtual double DiffusedCorrValue(const ModelPoint & pntFrom, 
										 const ModelPoint & pntTo);

		virtual VKString GetCollectionType();
	
		virtual void GetRegionCorrVals(std::vector<ModelPoint> & queryRegion,
									   const VKString & corrValue,
									   std::vector<ModelPoint> * corrPnts, 
									   std::vector<double> * corrVals);
		virtual void FillCorrMtx();
		virtual void AddEntry(int mtxID1, int mtxID2, double val);
		virtual void SolveForQueryRegion(std::vector<ModelPoint> & newQuery);
		virtual void SolveForQueryRegion();
		virtual bool AreQueryRegionsSame(std::vector<ModelPoint> & newQuery);
	
		LinAlgMatrixSparseReal * m_pCorrMtx;
		//LinAlgMatrixReal * m_pCorrMtx;
		std::map<int, bool> m_QueryRegion;
		LinAlgVectorReal * m_pQueryRegionVector;
	
		LinAlgVectorReal * m_pCurrRegionValues;
		std::vector<ModelPoint> m_CurrRegionCorrs;
	
		int m_iNPoints;
		int m_iNModels;
	
};

#endif


