/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __DistanceEuclidean_H
#define __DistanceEuclidean_H

#include "ModelDistance.h"

class DistanceEuclidean : public ModelDistance
{
	public:
		DistanceEuclidean(Model3D * model);
		virtual double Distance(const ModelPoint & p1, const ModelPoint & p2);
		virtual void GetNeighborhood(const ModelPoint & p1, double threshold, 
									 std::vector<ModelPoint> * trgPnts, 
									 const VKString & pointSet="auto");
		virtual ModelPoint GetClosestPoint(const ModelPoint & p1, 
										   const VKString & pointSet="auto");
		virtual ModelPoint GetClosestPoint(const R3Point & p1, 
										   const VKString & pointSet="auto");
		virtual double CalculateStandardNorm();
		virtual VKString DistanceType();

};

#endif
