/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/


#ifndef __ModelDeformation_H
#define __ModelDeformation_H

#include "Model3D.h"

class ModelDeformation
{
	public:
		ModelDeformation(Model3D * model, const VKString & speedupSet);
		
		virtual void PrepareForDeformation() = 0;
		virtual void SelectDeformableSet(std::vector<int> & pnts);
		virtual void MoveControlPoint(int pntID, const R3Vector & dv) = 0;
		virtual void Deform() = 0;
	
	protected:
		virtual void PropagateDeformations(const VKString & setTo, double interpolationNhd);	
		
		Model3D * m_pModel;
		std::vector<int> m_DeformableSelection;
		VKString m_sSpeedupSet;
	
		std::map<int, R3Vector> m_PendingDeformations;

		
};

#endif


