/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __ModelDistance_H
#define __ModelDistance_H

#include "VKString.h"

#include "ModelPoint.h"

class Model3D;

class ModelDistance
{
	public:
		ModelDistance(Model3D * model);
		virtual double Distance(const ModelPoint & p1, const ModelPoint & p2) = 0;
		virtual void GetNeighborhood(const ModelPoint & p1, double threshold, 
									 std::vector<ModelPoint> * trgPnts, 
									 const VKString & pointSet="auto") = 0;
		virtual ModelPoint GetClosestPoint(const ModelPoint & p1, 
										   const VKString & pointSet="auto") = 0;
		virtual VKString DistanceType() = 0;
		virtual double GetStandardNorm();
		virtual void SetStandardNorm(double norm);
	
	protected:
		virtual double CalculateStandardNorm();
		Model3D * m_pModel;
		double m_fNorm;
};

#endif
