/***************************************************************************
 *   Copyright (C) 2008 by Vladimir Kim									   *
 *   Author: Vladimir Kim (vk@princeton.edu)							   *
 ***************************************************************************/

#ifndef __ShapeDescriptor_H
#define __ShapeDescriptor_H

#include <vector>

#include "VKString.h"
#include "LinAlgVectorReal.h"


class Model3D;
class ModelDatabase;

class ShapeDescriptor
{
	public:
		ShapeDescriptor(Model3D * model);
		virtual void FillDescriptorValues();
		virtual void FindMyNearestNeighbors(std::vector<ShapeDescriptor*> & otherDescriptors, 
											int nNeighbors, 
											std::vector<ShapeDescriptor*> & neighbors,
											std::vector<double> * distances );
	
		Model3D * GetModel();
	
		virtual double MeasureSimilarity(ShapeDescriptor * otherDescriptor);
	
		static void QuickBatchWorkSHD(ModelDatabase * db, bool forceRecompute,
									  std::vector<ShapeDescriptor*> & descriptors);
		
	
		LinAlgVectorReal * m_pDescriptorVals;	
	
	protected:
		Model3D * m_pModel;
	
		
};

#endif
